//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//
//  ȉ~~̕`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0501 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TMyPanel = class(TPanel)
  protected
    procedure Paint; override;
  public
    FBrushColor : Cardinal;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+ CircleEllipse';

  //TMyPanel𐶐Ĕzu
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent  := Self;
    Left    := 5;
    Top     := 35;
    Width   := Self.ClientWidth  - 10;
    Height  := Self.ClientHeight - Top - 5;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Color   := clWhite;
    ParentBackground := False;
    DoubleBuffered   := True;

    FBrushColor := aclLime;
  end;
end;

//=============================================================================
//  uV̐FύX
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  ColorDialog1.Color := ARGBToColorRef(MyPanel.FBrushColor);
  if ColorDialog1.Execute then begin
    MyPanel.FBrushColor := ColorRefToARGB(ColorDialog1.Color);
  end;
  MyPanel.Invalidate;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//  ȉ~`̗
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LGPGraphic : TGPGraphics;
@LGPPen     : TGPPen;
  LGPBrush   : TGPSolidBrush;
  LGPRect    : TGPRect;
  LLeft      : Integer;
  LTop       : Integer;
  LDiameterW : Integer;
  LDiameterH : Integer;
  LPenWidth  : Integer;
begin
  inherited;

  LLeft  := 20;
  LTop   := 20;
  LDiameterW := 230;
  LDiameterH := 130;
  LPenWidth  := 13;


  //ỹIuWFNg𐶐
  LGPPen := TGPPen.Create(aclSkyBlue, LPenWidth);
  //TGPSolidBrush𐶐
  LGPBrush := TGPSolidBrush.Create(FBrushColor);

  //`̈w
  LGPRect := MakeRect(LLeft, LTop, LDiameterW, LDiameterH);

  //TGPGraphicsIuWFNg𐶐
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

  //hׂ
  //hׂKvȂΎsKv͂Ȃ(uV̐ݒsv)
  LGPGraphic.FillEllipse(LGPBrush, LGPRect);

  //̘͂g`
  //̕`֌W̊֐DrawXXXX
  LGPGraphic.DrawEllipse(LGPPen, LGPRect);


  //Ql`
  //ɐTGPPenIuWFNg̐FƐ̑ύXĎlp``
  LGPPen.SetColor(aclBlack);
  LGPPen.SetWidth(1.0);
  LGPGraphic.DrawRectangle(LGPPen, LGPRect);

  //CreateIuWFNg͉
  LGPPen.Free;
  LGPBrush.Free;
  LGPGraphic.Free;
end;

end.
